
/*
Any
=================================================
The type `any` is only used internally and matches any value. It is used as default
if nothing is specified for an value and makes the checks homogeneous.

`any` has no special options.


Schema Specification
---------------------------------------------------
{@schema #selfcheck}
 */

(function() {
  var rules, util;

  util = require('alinex-util');

  rules = require('../helper/rules');

  exports.describe = function(cb) {
    var text;
    text = "A value of any type. ";
    text += rules.optional.describe.call(this);
    text = text.replace(/\. It's/, ' which is');
    return cb(null, text);
  };

  exports.check = function(cb) {
    var skip;
    skip = rules.optional.check.call(this);
    if (skip instanceof Error) {
      return cb(skip);
    }
    if (skip) {
      return cb();
    }
    return this.sendSuccess(cb);
  };

  exports.selfcheck = {
    title: "Any",
    description: "any schema definition",
    type: 'object',
    allowedKeys: true,
    keys: util.extend({}, rules.baseSchema, {
      "default": {
        title: "Default Value",
        description: "the default value to use if nothing given",
        type: 'any',
        optional: true
      }
    })
  };

}).call(this);

//# sourceMappingURL=any.map